<template src="./template.html"></template>

<script lang="ts">
import { Watch, getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import _, { findLastKey } from "lodash";
import { getTimeZone } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");

interface IBodyCreate {
  couponId: string;
  code: string;
  discount: number;
  status: boolean;
  discountType: number;
  dateFrom: string;
  dateTo?: string;
  minAmount: number;
  minQuantity: number;
}

@Component({
  components: {},
})
export default class AdminDiscountEditComponent extends Vue {
  discount = {
    couponId: "",
    code: "",
    discount: 0,
    status: true,
    discountType: "1",
    minAmount: 0,
    minQuantity: 0,
  };

  checkboxMinimum = "1";
  minimumRequire = 0;

  isShowDateEnd = false;
  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = moment().endOf("day").format("YYYY-MM-DD");
  dateEnd = momentz().endOf("month").format("YYYY-MM-DD");

  menuTimePickerStart = false;
  menuTimePickerEnd = false;
  timePickerStart = moment().format("HH:mm");
  timePickerEnd = moment().format("HH:mm");

  discountId: string = "";

  loading = false;
  loadingDisable = false;
  loadingSwitch = false;
  dialogDisable = false;

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get timeZone() {
    return this.$store.state.setting.siteInfo.timezone || "-7";
  }

  mounted() {
    this.discountId = this.$route.params.id || "";
    if (this.discountId) {
      this.onGetDetailDiscount();
    }
  }

  async onGetDetailDiscount() {
    try {
      this.$store.commit("adminProduct/setLoadingFullPage", true);
      const response = await this.$api.AdminDiscount.getDetail(this.discountId);
      if (response?.data) {
        const {
          _id: couponId,
          code,
          dateFrom,
          dateTo,
          discount,
          discountType,
          status,
          minAmount,
          minQuantity,
        } = response.data;
        if (minAmount === 0 && minQuantity === 0) {
          this.checkboxMinimum = "1";
          this.minimumRequire = 0;
        }
        if (minAmount > 0) {
          this.checkboxMinimum = "2";
          this.minimumRequire = minAmount;
        }
        if (minQuantity > 0) {
          this.checkboxMinimum = "3";
          this.minimumRequire = minQuantity;
        }
        this.discount = {
          couponId,
          code,
          discount,
          discountType: `${discountType}`,
          status,
          minAmount,
          minQuantity,
        };
        const siteInfo = this.$store.state.setting.siteInfo;
        const timezone = getTimeZone(siteInfo.timezone);

        if (dateFrom) {
          this.dateStart = momentz
            .unix(dateFrom)
            .tz(timezone)
            .format("YYYY-MM-DD");
          this.timePickerStart = momentz
            .unix(dateFrom)
            .tz(timezone)
            .format("HH:mm");
        } else {
          this.dateStart = moment().endOf("day").format("YYYY-MM-DD");
          this.timePickerStart = moment().format("HH:mm");
        }
        if (dateTo) {
          this.isShowDateEnd = true;
          this.dateEnd = momentz.unix(dateTo).tz(timezone).format("YYYY-MM-DD");
          this.timePickerEnd = momentz
            .unix(dateTo)
            .tz(timezone)
            .format("HH:mm");
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.$store.commit("adminProduct/setLoadingFullPage", false);
    }
  }

  async onUpdate(isSwitch?: boolean) {
    try {
      if (!this.discount.code) {
        return this.$pushNotification.error("Please enter discount code");
      } else if (
        this.discount.discountType !== "3" &&
        !this.discount.discount
      ) {
        return this.$pushNotification.error("Please enter discount value");
      } else if (
        this.discount.discountType === "1" &&
        (this.discount.discount < 0 || this.discount.discount > 100)
      ) {
        return this.$pushNotification.error(
          "Discount value cannot be less than 0 and greater than 100"
        );
      }
      let body: IBodyCreate = {
        ...this.discount,
        minAmount: this.checkboxMinimum === "2" ? this.minimumRequire : 0,
        minQuantity: this.checkboxMinimum === "3" ? this.minimumRequire : 0,
        discountType: parseInt(this.discount.discountType),
        dateFrom: moment(this.from).unix(),
      };

      if (this.isShowDateEnd) {
        body.dateTo = moment(this.to).unix();
      }
      if (isSwitch) this.loadingSwitch = true;
      else this.loading = true;
      await this.$api.AdminDiscount.edit(body);
      this.$pushNotification.success("Update discount successfully");
      if (!isSwitch) this.$router.push("/seller/discounts");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
      this.loadingSwitch = false;
    }
  }

  async onDisable() {
    try {
      this.loadingDisable = true;
      await this.$api.AdminDiscount.edit({
        couponId: this.discount.couponId,
        status: false,
      });
      this.$pushNotification.success("Update status successfully");
      this.dialogDisable = false;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingDisable = false;
    }
  }

  onCancelDisable() {
    this.loadingDisable = false;
    this.dialogDisable = false;
    if (!this.discount.status) {
      this.discount.status = true;
    }
  }

  onSwitch(status: boolean) {
    if (!status) {
      this.dialogDisable = true;
    } else {
      this.onUpdate(true);
    }
  }

  onSetTime() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateStart,
      dateEnd: this.dateEnd,
      timeFrom: this.timePickerStart,
      timeTo: this.timePickerEnd,
    });
  }

  @Watch("dateStart")
  onChagedDateStart() {
    this.onSetTime();
  }

  @Watch("dateEnd")
  onChagedDateEnd() {
    this.onSetTime();
  }

  @Watch("timePickerStart")
  onChagedTimeStart() {
    this.onSetTime();
  }

  @Watch("timePickerEnd")
  onChagedTimeEnd() {
    this.onSetTime();
  }

  @Watch("discount.code")
  changedCodeName(value: string) {
    this.discount.code = value.toLocaleUpperCase();
  }
}
</script>

<style></style>
